package gregapi.load;

import static gregapi.data.CS.U;
import static gregapi.data.CS.W;
import gregapi.data.CS.ModIDs;
import gregapi.data.IL;
import gregapi.data.MT;
import gregapi.data.OP;
import gregapi.oredict.OreDictItemData;
import gregapi.recipes.GT_ModHandler;
import gregapi.util.OM;
import gregapi.util.UT;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;

/**
 * @author Gregorius Techneticies
 * 
 * Loads the ItemData for several Items.
 * This happens during the InitPhase, or if GregTech is installed within the PreInitPhase, since GregTech loads after all the Mods mentioned here, unlike the API.
 */
public class LoaderItemData implements Runnable {
	@Override
	public void run() {
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "item.giantPick", 1, 0)																	, new OreDictItemData(MT.Stone				,  U*192, OM.stack(MT.Wood, U*128)));
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "item.giantSword", 1, 0)																, new OreDictItemData(MT.Stone				,  U*128, OM.stack(MT.Wood, U* 64)));
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "tile.GiantLog", 1, W)																	, new OreDictItemData(MT.Wood				,  U *64));
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "tile.GiantCobble", 1, W)																, new OreDictItemData(MT.Stone				,  U *64));
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "tile.GiantObsidian", 1, W)																, new OreDictItemData(MT.Obsidian			,  U *64));
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "item.minotaurAxe", 1, 0)																, new OreDictItemData(MT.Diamond			,  U * 4, OM.stack(MT.Wood, OP.stick.mAmount * 2)));
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "item.armorShards", 1, 0)																, new OreDictItemData(MT.Knightmetal		,  U / 9));
        OM.data(GT_ModHandler.getModItem(ModIDs.TF, "item.shardCluster", 1, 0)																, new OreDictItemData(MT.Knightmetal		,  U * 1));
        OM.data(IL.TF_LiveRoot.get(1)																										, new OreDictItemData(MT.LiveRoot			,  U * 1));
		OM.data(GT_ModHandler.getModItem(ModIDs.AE, "item.ItemMultiMaterial", 1, 10)														, new OreDictItemData(MT.CertusQuartz		,  U / 2));
        OM.data(GT_ModHandler.getModItem(ModIDs.AE, "item.ItemMultiMaterial", 1, 11)														, new OreDictItemData(MT.NetherQuartz		,  U / 2));
        OM.data(GT_ModHandler.getModItem(ModIDs.AE, "item.ItemMultiMaterial", 1, 12)														, new OreDictItemData(MT.UNUSED.Fluix		,  U / 2));
        OM.data(new ItemStack(Blocks.quartz_block, 1, W)																					, new OreDictItemData(MT.NetherQuartz		,  U * 4));
        OM.data(GT_ModHandler.getModItem(ModIDs.AE, "tile.BlockQuartz"			, 1, W)														, new OreDictItemData(MT.CertusQuartz		,  U * 4));
        OM.data(GT_ModHandler.getModItem(ModIDs.AE, "tile.BlockQuartzPillar"	, 1, W)														, new OreDictItemData(MT.CertusQuartz		,  U * 4));
        OM.data(GT_ModHandler.getModItem(ModIDs.AE, "tile.BlockQuartzChiseled"	, 1, W)														, new OreDictItemData(MT.CertusQuartz		,  U * 4));
        OM.data(new ItemStack(Items.wheat, 1, W)																							, new OreDictItemData(MT.Wheat				,  U * 1));
        OM.data(new ItemStack(Blocks.hay_block, 1, W)																						, new OreDictItemData(MT.Wheat				,  U * 9));
        OM.data(new ItemStack(Items.snowball, 1, W)																							, new OreDictItemData(MT.Snow				,  U / 4));
        OM.data(new ItemStack(Blocks.snow, 1, W)																							, new OreDictItemData(MT.Snow				,  U * 1));
        OM.data(new ItemStack(Blocks.glowstone, 1, W)																						, new OreDictItemData(MT.Glowstone			,  U * 4));
        OM.data(new ItemStack(Blocks.redstone_lamp, 1, W)																					, new OreDictItemData(MT.Glowstone			,  U * 4, OM.stack(MT.Redstone, OP.dust.mAmount * 4)));
        OM.data(new ItemStack(Blocks.lit_redstone_lamp, 1, W)																				, new OreDictItemData(MT.Glowstone			,  U * 4, OM.stack(MT.Redstone, OP.dust.mAmount * 4)));
        OM.data(GT_ModHandler.getModItem(ModIDs.FR, "craftingMaterial", 1, 5)																, new OreDictItemData(MT.Ice				,  U * 1));
        OM.data(new ItemStack(Blocks.ice, 1, W)																								, new OreDictItemData(MT.Ice				,  U * 1));
        OM.data(new ItemStack(Blocks.packed_ice, 1, W)																						, new OreDictItemData(MT.Ice				,  U * 2));
        OM.data(new ItemStack(Items.clay_ball					, 1, W)																		, new OreDictItemData(MT.Clay				,  U / 2));
        OM.data(new ItemStack(Blocks.clay						, 1, W)																		, new OreDictItemData(MT.Clay				,  U * 2));
        OM.data(new ItemStack(Blocks.hardened_clay				, 1, W)																		, new OreDictItemData(MT.Clay				,  U * 1));
        OM.data(new ItemStack(Blocks.stained_hardened_clay		, 1, W)																		, new OreDictItemData(MT.Clay				,  U * 1));
        OM.data(new ItemStack(Blocks.brick_block				, 1, W)																		, new OreDictItemData(MT.Clay				,  U * 1));
        OM.data(GT_ModHandler.getIC2Item("Uran238", 1)																						, new OreDictItemData(MT.Uranium			,  U * 1));
        OM.data(GT_ModHandler.getIC2Item("Uran235", 1)																						, new OreDictItemData(MT.Uranium235			,  U * 1));
        OM.data(GT_ModHandler.getIC2Item("Plutonium", 1)																					, new OreDictItemData(MT.Plutonium			,  U * 1));
        OM.data(GT_ModHandler.getIC2Item("smallUran235", 1)																					, new OreDictItemData(MT.Uranium235			,  U / 9));
        OM.data(GT_ModHandler.getIC2Item("smallPlutonium", 1)																				, new OreDictItemData(MT.Plutonium			,  U / 9));
        OM.data(IL.IC2_Item_Casing_Iron.get(1)																								, new OreDictItemData(MT.Iron				,  U / 2));
        OM.data(IL.IC2_Item_Casing_Gold.get(1)																								, new OreDictItemData(MT.Gold				,  U / 2));
        OM.data(IL.IC2_Item_Casing_Bronze.get(1)																							, new OreDictItemData(MT.Bronze				,  U / 2));
        OM.data(IL.IC2_Item_Casing_Copper.get(1)																							, new OreDictItemData(MT.Copper				,  U / 2));
        OM.data(IL.IC2_Item_Casing_Tin.get(1)																								, new OreDictItemData(MT.Tin				,  U / 2));
        OM.data(IL.IC2_Item_Casing_Lead.get(1)																								, new OreDictItemData(MT.Lead				,  U / 2));
        OM.data(IL.IC2_Item_Casing_Steel.get(1)																								, new OreDictItemData(MT.Steel				,  U / 2));
        OM.data(new ItemStack(Items.book, 1, W)																								, new OreDictItemData(MT.Paper				,  U * 3));
        OM.data(new ItemStack(Items.written_book, 1, W)																						, new OreDictItemData(MT.Paper				,  U * 3));
        OM.data(new ItemStack(Items.writable_book, 1, W)																					, new OreDictItemData(MT.Paper				,  U * 3));
        OM.data(new ItemStack(Items.enchanted_book, 1, W)																					, new OreDictItemData(MT.Paper				,  U * 3));
        OM.data(new ItemStack(Items.golden_apple, 1, 1)																						, new OreDictItemData(MT.Gold				,  OP.block.mAmount * 8));
        OM.data(new ItemStack(Items.golden_apple, 1, 0)																						, new OreDictItemData(MT.Gold				,  OP.ingot.mAmount * 8));
        OM.data(new ItemStack(Items.golden_carrot, 1, 0)																					, new OreDictItemData(MT.Gold				,  OP.nugget.mAmount * 8));
        OM.data(new ItemStack(Items.speckled_melon, 1, 0)																					, new OreDictItemData(MT.Gold				,  OP.nugget.mAmount * 8));
        OM.data(new ItemStack(Items.minecart, 1)																							, new OreDictItemData(MT.Iron				,  U * 5));
        OM.data(new ItemStack(Items.iron_door, 1)																							, new OreDictItemData(MT.Iron				,  U * 6));
        OM.data(new ItemStack(Items.cauldron, 1)																							, new OreDictItemData(MT.Iron				,  U * 7));
        OM.data(new ItemStack(Blocks.iron_bars, 8, W)																						, new OreDictItemData(MT.Iron				,  U * 3));
        OM.data(GT_ModHandler.getIC2Item("ironFurnace", 1)																					, new OreDictItemData(MT.Iron				,  U * 5));
        OM.data(IL.IC2_Food_Can_Empty.get(1)																								, new OreDictItemData(MT.Tin				,  U / 2));
        OM.data(IL.IC2_Fuel_Rod_Empty.get(1)																								, new OreDictItemData(MT.Iron				,  U    ));
        OM.data(new ItemStack(Blocks.light_weighted_pressure_plate, 1, W)																	, new OreDictItemData(MT.Gold				,  U * 2));
        OM.data(new ItemStack(Blocks.heavy_weighted_pressure_plate, 1, W)																	, new OreDictItemData(MT.Iron				,  U * 2));
        OM.data(GT_ModHandler.getModItem(ModIDs.RC, "tile.railcraft.anvil", 1, 0)															, new OreDictItemData(MT.Steel				,  U *30));
        OM.data(GT_ModHandler.getModItem(ModIDs.RC, "tile.railcraft.anvil", 1, 1)															, new OreDictItemData(MT.Steel				,  U *20));
        OM.data(GT_ModHandler.getModItem(ModIDs.RC, "tile.railcraft.anvil", 1, 2)															, new OreDictItemData(MT.Steel				,  U *10));
        OM.data(new ItemStack(Blocks.anvil, 1, 0)																							, new OreDictItemData(MT.Iron				,  U *30));
        OM.data(new ItemStack(Blocks.anvil, 1, 1)																							, new OreDictItemData(MT.Iron				,  U *20));
        OM.data(new ItemStack(Blocks.anvil, 1, 2)																							, new OreDictItemData(MT.Iron				,  U *10));
        OM.data(new ItemStack(Blocks.hopper, 1, W)																							, new OreDictItemData(MT.Iron				,  U * 5 , OM.stack(MT.Wood, U * 8)));
		OM.data(IL.Cell_Universal_Fluid.get(1)																								, new OreDictItemData(MT.Tin				,  U * 2 , OM.stack(MT.Glass, (U * 3)/ 8)));
		OM.data(IL.Cell_Empty.get(1)																										, new OreDictItemData(MT.Tin				,  U * 2));
        OM.data(new ItemStack(Blocks.tripwire_hook, 1, W)																					, new OreDictItemData(MT.Iron				,  OP.ring.mAmount * 2, OM.stack(MT.Wood, U)));
        OM.data(IL.Bottle_Empty.get(1)																										, new OreDictItemData(MT.Glass				,  U));
        OM.data(new ItemStack(Items.potionitem, 1, W)																						, new OreDictItemData(MT.Glass				,  U));
        OM.data(new ItemStack(Blocks.stained_glass			, 1, W)																			, new OreDictItemData(MT.Glass				,  U));
        OM.data(new ItemStack(Blocks.glass					, 1, W)																			, new OreDictItemData(MT.Glass				,  U));
        OM.data(new ItemStack(Blocks.stained_glass_pane	, 1, W)																				, new OreDictItemData(MT.Glass				, (U * 3)/ 8));
        OM.data(new ItemStack(Blocks.glass_pane			, 1, W)																				, new OreDictItemData(MT.Glass				, (U * 3)/ 8));
        OM.data(new ItemStack(Items.clock, 1, W)																							, new OreDictItemData(MT.Gold				,  U * 4 , OM.stack(MT.Redstone, U)));
        OM.data(new ItemStack(Items.compass, 1, W)																							, new OreDictItemData(MT.Iron				,  U * 4 , OM.stack(MT.Redstone, U)));
        OM.data(new ItemStack(Items.iron_horse_armor, 1, W)																					, new OreDictItemData(MT.Iron				,  U * 8 , OM.stack(MT.UNUSED.Leather, U * 6)));
        OM.data(new ItemStack(Items.golden_horse_armor, 1, W)																				, new OreDictItemData(MT.Gold				,  U * 8 , OM.stack(MT.UNUSED.Leather, U * 6)));
        OM.data(new ItemStack(Items.diamond_horse_armor, 1, W)																				, new OreDictItemData(MT.Diamond			,  U * 8 , OM.stack(MT.UNUSED.Leather, U * 6)));
        OM.data(new ItemStack(Items.leather, 1, W)																							, new OreDictItemData(MT.UNUSED.Leather		,  U * 1 ));
        OM.data(new ItemStack(Blocks.beacon, 1, W)																							, new OreDictItemData(MT.NetherStar			,  U * 1 , OM.stack(MT.Obsidian, U * 3), OM.stack(MT.Glass, U * 5)));
        OM.data(new ItemStack(Blocks.enchanting_table, 1, W)																				, new OreDictItemData(MT.Diamond			,  U * 2 , OM.stack(MT.Obsidian, U * 4), OM.stack(MT.Paper, U * 3)));
        OM.data(new ItemStack(Blocks.ender_chest, 1, W)																						, new OreDictItemData(MT.EnderEye			,  U * 1 , OM.stack(MT.Obsidian, U * 8)));
        OM.data(new ItemStack(Blocks.bookshelf, 1, W)																						, new OreDictItemData(MT.Paper				,  U * 9 , OM.stack(MT.Wood, U * 6)));
        OM.data(new ItemStack(Blocks.lever, 1, W)																							, new OreDictItemData(MT.Stone				,  U * 1 , OM.stack(MT.Wood, U / 2)));
        OM.data(new ItemStack(Blocks.ice, 1, W)																								, new OreDictItemData(MT.Ice				,  U * 1 ));
        OM.data(new ItemStack(Blocks.packed_ice, 1, W)																						, new OreDictItemData(MT.Ice				,  U * 2 ));
        OM.data(new ItemStack(Blocks.snow, 1, W)																							, new OreDictItemData(MT.Snow				,  U * 1 ));
        OM.data(new ItemStack(Items.snowball, 1, W)																							, new OreDictItemData(MT.Snow				,  U / 4 ));
        OM.data(new ItemStack(Blocks.snow_layer, 1, W)																						, new OreDictItemData(MT.Snow				,     -1 ));
        OM.data(new ItemStack(Blocks.sand, 1, W)																							, new OreDictItemData(MT.Sand				,  U * 1 ));
        OM.data(new ItemStack(Blocks.sandstone, 1, W)																						, new OreDictItemData(MT.Sand				,  U * 1 ));
        OM.data(new ItemStack(Blocks.stone_slab, 1, 0)																						, new OreDictItemData(MT.Stone				,  U / 2 ));
        OM.data(new ItemStack(Blocks.stone_slab, 1, 8)																						, new OreDictItemData(MT.Stone				,  U / 2 ));
        OM.data(new ItemStack(Blocks.double_stone_slab, 1, 0)																				, new OreDictItemData(MT.Stone				,  U * 1 ));
        OM.data(new ItemStack(Blocks.double_stone_slab, 1, 8)																				, new OreDictItemData(MT.Stone				,  U * 1 ));
        OM.data(new ItemStack(Blocks.stone_slab, 1, 1)																						, new OreDictItemData(MT.Sand				,  U / 2 ));
        OM.data(new ItemStack(Blocks.stone_slab, 1, 9)																						, new OreDictItemData(MT.Sand				,  U / 2 ));
        OM.data(new ItemStack(Blocks.double_stone_slab, 1, 1)																				, new OreDictItemData(MT.Sand				,  U * 1 ));
        OM.data(new ItemStack(Blocks.double_stone_slab, 1, 9)																				, new OreDictItemData(MT.Sand				,  U * 1 ));
        OM.data(new ItemStack(Blocks.stone_slab, 1,  2)																						, new OreDictItemData(MT.Wood				,  U / 2 ));
        OM.data(new ItemStack(Blocks.stone_slab, 1, 10)																						, new OreDictItemData(MT.Wood				,  U / 2 ));
        OM.data(new ItemStack(Blocks.double_stone_slab, 1,  2)																				, new OreDictItemData(MT.Wood				,  U * 1 ));
        OM.data(new ItemStack(Blocks.double_stone_slab, 1, 10)																				, new OreDictItemData(MT.Wood				,  U * 1 ));
        OM.data(new ItemStack(Blocks.stone_slab, 1,  3)																						, new OreDictItemData(MT.Stone				,  U / 2 ));
        OM.data(new ItemStack(Blocks.stone_slab, 1, 11)																						, new OreDictItemData(MT.Stone				,  U / 2 ));
        OM.data(new ItemStack(Blocks.double_stone_slab, 1,  3)																				, new OreDictItemData(MT.Stone				,  U * 1 ));
        OM.data(new ItemStack(Blocks.double_stone_slab, 1, 11)																				, new OreDictItemData(MT.Stone				,  U * 1 ));
        OM.data(new ItemStack(Blocks.stone_slab, 1,  5)																						, new OreDictItemData(MT.Stone				,  U / 2 ));
        OM.data(new ItemStack(Blocks.stone_slab, 1, 13)																						, new OreDictItemData(MT.Stone				,  U / 2 ));
        OM.data(new ItemStack(Blocks.double_stone_slab, 1,  5)																				, new OreDictItemData(MT.Stone				,  U * 1 ));
        OM.data(new ItemStack(Blocks.double_stone_slab, 1, 13)																				, new OreDictItemData(MT.Stone				,  U * 1 ));
        OM.data(new ItemStack(Blocks.stone, 1, W)																							, new OreDictItemData(MT.Stone				,  U * 1 ));
        OM.data(new ItemStack(Blocks.furnace, 1, W)																							, new OreDictItemData(MT.Stone				,  U * 8 ));
        OM.data(new ItemStack(Blocks.lit_furnace, 1, W)																						, new OreDictItemData(MT.Stone				,  U * 8 ));
        OM.data(new ItemStack(Blocks.stonebrick, 1, W)																						, new OreDictItemData(MT.Stone				,  U * 1 ));
        OM.data(new ItemStack(Blocks.cobblestone, 1, W)																						, new OreDictItemData(MT.Stone				,  U * 1 ));
        OM.data(new ItemStack(Blocks.mossy_cobblestone, 1, W)																				, new OreDictItemData(MT.Stone				,  U * 1 ));
        OM.data(new ItemStack(Blocks.stone_button, 1, W)																					, new OreDictItemData(MT.Stone				,  U * 1 ));
        OM.data(new ItemStack(Blocks.stone_pressure_plate, 1, W)																			, new OreDictItemData(MT.Stone				,  U * 2 ));
        OM.data(new ItemStack(Blocks.ladder, 1, W)																							, new OreDictItemData(MT.Wood				,  U * 1 ));
        OM.data(new ItemStack(Blocks.wooden_button, 1, W)																					, new OreDictItemData(MT.Wood				,  U * 1 ));
        OM.data(new ItemStack(Blocks.wooden_pressure_plate, 1, W)																			, new OreDictItemData(MT.Wood				,  U * 2 ));
        OM.data(new ItemStack(Blocks.fence, 1, W)																							, new OreDictItemData(MT.Wood				, (U * 3)/ 2));
        OM.data(new ItemStack(Items.bowl, 1, W)																								, new OreDictItemData(MT.Wood				,  U * 1 ));
        OM.data(new ItemStack(Items.sign, 1, W)																								, new OreDictItemData(MT.Wood				,  U * 2 ));
        OM.data(new ItemStack(Items.wooden_door, 1, W)																						, new OreDictItemData(MT.Wood				,  U * 6 ));
        OM.data(new ItemStack(Blocks.chest, 1, W)																							, new OreDictItemData(MT.Wood				,  U * 8 ));
        OM.data(new ItemStack(Blocks.trapped_chest, 1, W)																					, new OreDictItemData(MT.Wood				,  U * 9 , OM.stack(MT.Iron, OP.ring.mAmount * 2)));
        OM.data(new ItemStack(Blocks.unlit_redstone_torch, 1, W)																			, new OreDictItemData(MT.Wood				,  U / 2 , OM.stack(MT.Redstone, U)));
        OM.data(new ItemStack(Blocks.redstone_torch, 1, W)																					, new OreDictItemData(MT.Wood				,  U / 2 , OM.stack(MT.Redstone, U)));
        OM.data(new ItemStack(Blocks.noteblock, 1, W)																						, new OreDictItemData(MT.Wood				,  U * 8 , OM.stack(MT.Redstone, U)));
        OM.data(new ItemStack(Blocks.jukebox, 1, W)																							, new OreDictItemData(MT.Wood				,  U * 8 , OM.stack(MT.Diamond, U)));
        OM.data(new ItemStack(Blocks.crafting_table, 1, W)																					, new OreDictItemData(MT.Wood				,  U * 4 ));
        OM.data(new ItemStack(Blocks.piston, 1, W)																							, new OreDictItemData(MT.Stone				,  U * 4 , OM.stack(MT.Wood, U * 3)));
        OM.data(new ItemStack(Blocks.sticky_piston, 1, W)																					, new OreDictItemData(MT.Stone				,  U * 4 , OM.stack(MT.Wood, U * 3)));
        OM.data(new ItemStack(Blocks.dispenser, 1, W)																						, new OreDictItemData(MT.Stone				,  U * 7 , OM.stack(MT.Redstone, U)));
        OM.data(new ItemStack(Blocks.dropper, 1, W)																							, new OreDictItemData(MT.Stone				,  U * 7 , OM.stack(MT.Redstone, U)));
        OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemNuggetChicken"	, 1, W)																, new OreDictItemData(MT.MeatCooked			,  U / 9 ));
    	OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemNuggetBeef"		, 1, W)															, new OreDictItemData(MT.MeatCooked			,  U / 9 ));
    	OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemNuggetPork"		, 1, W)															, new OreDictItemData(MT.MeatCooked			,  U / 9 ));
    	OM.data(GT_ModHandler.getModItem(ModIDs.TC, "ItemNuggetFish"		, 1, W)															, new OreDictItemData(MT.MeatCooked			,  U / 9 ));
    	
		for (ItemStack tItem : new ItemStack[] {GT_ModHandler.getModItem(ModIDs.TF, "item.meefRaw", 1, 0), GT_ModHandler.getModItem(ModIDs.TF, "item.venisonRaw", 1, 0), new ItemStack(Items.porkchop), new ItemStack(Items.beef), new ItemStack(Items.chicken), new ItemStack(Items.fish)}) if (tItem != null) {
			OM.data(UT.Stacks.copyMeta(W, tItem)																					, new OreDictItemData(MT.MeatRaw			,  U     , OM.stack(MT.Bone, U / 9)));
		}
		for (ItemStack tItem : new ItemStack[] {GT_ModHandler.getModItem(ModIDs.TF, "item.meefSteak", 1, 0), GT_ModHandler.getModItem(ModIDs.TF, "item.venisonCooked", 1, 0), new ItemStack(Items.cooked_porkchop), new ItemStack(Items.cooked_beef), new ItemStack(Items.cooked_chicken), new ItemStack(Items.cooked_fished)}) if (tItem != null) {
			OM.data(UT.Stacks.copyMeta(W, tItem)																					, new OreDictItemData(MT.MeatCooked			,  U     , OM.stack(MT.Bone, U / 9)));
		}
	}
}