package gregapi.old.metatileentity.examples;

import gregapi.old.GregTech_API;
import gregapi.old.Textures;
import gregapi.old.interfaces.tileentity.IGregTechTileEntity;
import gregapi.old.metatileentity.MetaTileEntity;
import gregapi.old.metatileentity.implementations.GT_MetaTileEntity_BasicMachine;
import gregapi.recipes.GT_ModHandler;
import gregapi.render.BlockTextureDefault;
import gregapi.render.ITexture;
import gregapi.util.UT;
import net.minecraft.item.ItemStack;

/**
 * This Example Implementation still works, however I use something completely different in my own Code.
 */
public class GT_MetaTileEntity_E_Furnace extends GT_MetaTileEntity_BasicMachine {
	public GT_MetaTileEntity_E_Furnace(int aID, String aName, String aNameRegional, int aTier) {
		super(aID, aName, aNameRegional, aTier, 1, "Not like using a Commodore 64", 1, 1, "E_Furnace.png", "smelting", new BlockTextureDefault(Textures.BlockIcons.OVERLAY_SIDE_STEAM_FURNACE_ACTIVE), new BlockTextureDefault(Textures.BlockIcons.OVERLAY_SIDE_STEAM_FURNACE), new BlockTextureDefault(Textures.BlockIcons.OVERLAY_FRONT_STEAM_FURNACE_ACTIVE), new BlockTextureDefault(Textures.BlockIcons.OVERLAY_FRONT_STEAM_FURNACE), new BlockTextureDefault(Textures.BlockIcons.OVERLAY_TOP_STEAM_FURNACE_ACTIVE), new BlockTextureDefault(Textures.BlockIcons.OVERLAY_TOP_STEAM_FURNACE), new BlockTextureDefault(Textures.BlockIcons.OVERLAY_BOTTOM_STEAM_FURNACE_ACTIVE), new BlockTextureDefault(Textures.BlockIcons.OVERLAY_BOTTOM_STEAM_FURNACE));
	}
	
	public GT_MetaTileEntity_E_Furnace(String aName, int aTier, String aDescription, ITexture[][][] aTextures, String aGUIName, String aNEIName) {
		super(aName, aTier, 1, aDescription, aTextures, 1, 1, aGUIName, aNEIName);
	}
	
	@Override
	public MetaTileEntity newMetaEntity(IGregTechTileEntity aTileEntity) {
		return new GT_MetaTileEntity_E_Furnace(mName, mTier, mDescription, mTextures, mGUIName, mNEIName);
	}
	
	@Override
    public int checkRecipe() {
    	if (null != (mOutputItems[0] = GT_ModHandler.getSmeltingOutput(getInputAt(0), true, getOutputAt(0)))) {
    		mEUt = 4 * (1 << (mTier-1)) * (1 << (mTier-1));
    		mMaxProgresstime = 128 / (1 << (mTier-1));
    		return 2;
    	}
    	return 0;
    }
	
	@Override
	public boolean allowPutStack(IGregTechTileEntity aBaseMetaTileEntity, int aIndex, byte aSide, ItemStack aStack) {
		return super.allowPutStack(aBaseMetaTileEntity, aIndex, aSide, aStack) && GT_ModHandler.getSmeltingOutput(UT.Stacks.copyAmount(64, aStack), false, null) != null;
	}
	
	@Override
	public void startSoundLoop(byte aIndex, double aX, double aY, double aZ) {
		super.startSoundLoop(aIndex, aX, aY, aZ);
		if (aIndex == 1) UT.Sounds.play(GregTech_API.sSoundList.get(207), 10, 1.0F, aX, aY, aZ);
	}
	
	@Override
	public void startProcess() {
		sendLoopStart((byte)1);
	}
}